﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using TS = System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.Administrator.Views.Common {
  public partial class UpdateControl : UserControl {
    public UpdateControl() {
      InitializeComponent();
    }

    public Action UpdateAction { get; set; }

    public void Update() {
      btnRefresh_Click(this, null);
    }

    private void PrivUpdateAction() {
      UpdateAction();
      if (imgBoxProgress.InvokeRequired) {
        imgBoxProgress.Invoke(new MethodInvoker(() => imgBoxProgress.Visible = false));
        btnRefresh.Invoke(new MethodInvoker(() => btnRefresh.Enabled = true));
      } else {
        imgBoxProgress.Visible = false;
        btnRefresh.Enabled = true;
      }
    }

    private void btnRefresh_Click(object sender, EventArgs e) {
      if (UpdateAction != null) {
        if (imgBoxProgress.InvokeRequired) {
          imgBoxProgress.Invoke(new MethodInvoker(() => imgBoxProgress.Visible = true));
          btnRefresh.Invoke(new MethodInvoker(() => btnRefresh.Enabled = false));
        } else {
          imgBoxProgress.Visible = true;
          btnRefresh.Enabled = false;
        }

        Action action = new Action(PrivUpdateAction);
        TS.Task task = new TS.Task(action);
        task.Start();
      }
    }
  }
}
