﻿
using System.Drawing;
using HeuristicLab.Clients.Hive.Jobs;
using HeuristicLab.Core;
using HeuristicLab.Optimization;
namespace HeuristicLab.Clients.Hive.Views.ExperimentManager.TreeView {
  public class DeleteTaskTreeNodeAction : IItemTreeNodeAction<HiveTask> {
    private ItemCollection<HiveTask> hiveTasks;

    public DeleteTaskTreeNodeAction(ItemCollection<HiveTask> hiveTasks) {
      this.hiveTasks = hiveTasks;
    }

    public string Name {
      get { return "Delete Task"; }
    }

    public Image Image {
      get { return null; }
    }

    public void Execute(HiveTask item, HiveTask parentItem) {
      if (parentItem == null) {
        hiveTasks.Remove(item);
      } else {
        var experiment = parentItem.ItemTask.Item as Experiment;
        if (experiment != null) {
          experiment.Optimizers.Remove(((OptimizerTask)item.ItemTask).Item);
        }
      }
    }
  }
}
